import { Serial } from "syrus4-nodejs"

export class Satcom {
	constructor({name}) {
		this.name = name
		this.onConnect = null;
		this.onDisconnect = null;
		this.onMessage = null;
		this.active = true
	}

	get disable_welcome_message() { return true }

	connect() { if (this.onConnect) this.onConnect() }
	disconnect() { if (this.onDisconnect) this.onDisconnect() }

	enable() {
		if (!this.active) {
			console.log(`satcom(${this.name}): enabled`);
			this.active = true;
			this.connect()
		}
	}
	disable() {
		if (this.active) {
			console.log(`satcom(${this.name}): disabled`);
			this.active = false;
		}
	}
	destroy() {}

	send(data, next) {
		if (!next) { next = () => { } }
		if (!this.active) return false;
		console.info("satcom:send", data);
		Serial.send(data).then(next).catch(console.error)
		return
	}
}
